/*------------------------------------------------------------------------
   (C) COPYRIGHT HEWLETT-PACKARD GmbH 1994-1996
   
   Project:  HP ELOQUENCE
   Module:   dmdrv
   File:     dmdrv_srv.h
   Function: server settings

   loaded from dmdrv.h if DMDRV_CLIENT_API is not set

   Configuration:

      DMDRV_PRIVATE    - defined to access internal data structures

      DMDRV_CLIENT_API - by default, SERVER api definition is visible.

      DLGAPI_INCLUDED  - make client wrapper prototypes visible
                         only meaningfull if DMDRV_CLIENT_API defined

   Edit history:
   
   09.01.96 - split

------------------------------------------------------------------------*/

/* @(#)$Revision$ */


/*
   D R I V E R   G L O B A L S
*/

/* driver specific setup/cleanup */
extern void FAR PASCAL dmdrv_setup( int argc, char FAR * FAR *argv );
extern void FAR PASCAL dmdrv_cleanup( void );

/* */
extern void FAR PASCAL dmdrv_main( void );
extern int  FAR PASCAL dmdrv_main_loop( long exit_rule, LPCSTR exit_path );

#ifdef __DMUSER_INCLUDED__
extern int FAR PASCAL dmdrv_attach_dialog(DM_ID objID, long value);
#endif

/* process client request */
extern int FAR PASCAL dmdrv_schedule( t_DMDRV FAR *arg );


/*
   S E R V E R   G L O B A L S
*/

extern int dmdrv_debug_flag;

extern void FAR PASCAL dmdrv_kill( void );
extern void FAR CDECL dmdrv_debug( int level, LPCSTR fmt, ... );
extern void FAR CDECL dmdrv_error( LPCSTR fmt, ... );

#ifdef DOS
extern int FAR PASCAL dmdrv_evnt( void );
#else
extern void dmdrv_evnt( void );
#endif

extern void FAR PASCAL dmdrv_return( const t_DMDRV FAR *req );
extern int FAR PASCAL dmdrv_callback( const t_DMDRV FAR *req, const t_DMDRV FAR **res );

#ifdef DMDRV_PRIVATE

/* data interface */
extern void FAR PASCAL drv_hton( const t_DMDRV FAR *arg_p );
extern void FAR PASCAL drv_ntoh( t_DMDRV FAR *arg_p );

/* ipc */
extern int FAR PASCAL ipc_setup( LPCSTR service );
extern void FAR PASCAL ipc_cleanup( void );
extern int FAR PASCAL ipc_send( void );
extern int FAR PASCAL ipc_schedule( void );

extern t_DMDRV_INFO FAR *dmdrv_info;

#endif   /* DMDRV_PRIVATE */
