/*------------------------------------------------------------------------
   (C) COPYRIGHT HEWLETT-PACKARD GmbH 1994
   
   Project:  HP ELOQUENCE
   Module:   dmdrv
   File:     server.h
   Function: server common - hpux specific

   Edit history:

------------------------------------------------------------------------*/

/* config file and section */

#define INI_FILE    "eloq.ini"
#define INI_SECTION "DmSrv"

/* config data */

struct Config {
   size_t memsz;           /* size of internal memory */
   int debug;              /* debug level */
   char def_fname[256];    /* defaults file */
   char dlg[5];            /* dlg extension */
   char idm[5];            /* idm extension */
   char idc[5];            /* idc extension */
   char netscape[256];     /* NETSCAPE viewer */
   char help_base_url[80]; /* online help base URL */
   char file_base_url[80]; /* file view base URL */
   char man_base_url[80];  /* man page base URL */
};

extern struct Config config;


/* driver debug level */
extern int dmdrv_debug_flag;

/* pointer to arg info */
extern t_DMDRV_INFO FAR *dmdrv_info;

/* some prototypes of global interest */
void StatusMessage( const char FAR *fmt, ...);
void DebugMessage( const char FAR *fmt, ...);
void WarningMessage( const char FAR *fmt, ...);
void ErrorMessage( const char FAR *fmt, ...);
