/* ----------------------------------------------------------------------
   (C) COPYRIGHT HEWLETT-PACKARD GmbH 1994
   
   Project:  HP ELOQUENCE
   Module:   dlg / dm
   File:     bind.c
   Function: bind callback functions

   Edit history:
   20.01.94 - derived from m_load.c

---------------------------------------------------------------------- */

static char RcsId[] =
   "$Header$";


/* ----------------------------------------------------------------------
      includes
---------------------------------------------------------------------- */

#include <IDMuser.h>

/* this is used to validate prototypes, if omitted include <windows.h> */
#include "dmdrv.h"


/* ----------------------------------------------------------------------

   bind callbacks

---------------------------------------------------------------------- */

/* callback functions */

boolean DML_default DM_CALLBACK CB_PushButton(DM_CallBackArgs FAR *);
boolean DML_default DM_CALLBACK CB_CheckBox(DM_CallBackArgs FAR *);
boolean DML_default DM_CALLBACK CB_RadioButton(DM_CallBackArgs FAR *);
boolean DML_default DM_CALLBACK CB_ListBox(DM_CallBackArgs FAR *);
boolean DML_default DM_CALLBACK CB_EditText(DM_CallBackArgs FAR *);

/* internal */

void DML_default DM_ENTRY ExitEventLoop(DM_ID, long);
boolean DML_default DM_ENTRY CallBack(LPCSTR, DM_ID, long);

/* help functionality */

boolean DML_default DM_ENTRY HelpOnObject(DM_ID);
boolean DML_default DM_ENTRY HelpOnTag(DM_ID, LPCSTR);
boolean DML_default DM_ENTRY HelpViewFile(LPCSTR);
boolean DML_default DM_ENTRY HelpManPage(LPCSTR);
boolean DML_default DM_ENTRY CallHelp(LPCSTR, LPCSTR);

/* obsolete dialog functions */
boolean DML_default DM_ENTRY Obsolete1(DM_ID p1)
{
   (void)p1;
   return FALSE;
}
boolean DML_default DM_ENTRY Obsolete2(DM_ID p1, LPCSTR p2)
{
   (void)p1;
   (void)p2;
   return FALSE;
}
boolean DML_default DM_ENTRY Obsolete3(LPCSTR p1, LPCSTR p2)
{
   (void)p1;
   (void)p2;
   return FALSE;
}


#define CFuncCount (sizeof(CFuncMap) / sizeof(CFuncMap[0]))

static DM_FuncMap CFuncMap[] = {
/**/
   { "EqPushButtonCB",    (DM_EntryFunc) CB_PushButton     },
   { "EqRadioButtonCB",   (DM_EntryFunc) CB_RadioButton    },
   { "EqCheckBoxCB",      (DM_EntryFunc) CB_CheckBox       },
   { "EqListBoxCB",       (DM_EntryFunc) CB_ListBox        },
   { "EqEditTextCB",      (DM_EntryFunc) CB_EditText       },
/**/
   { "EqExitEventLoop",   (DM_EntryFunc) ExitEventLoop     },
   { "EqCallBack",        (DM_EntryFunc) CallBack          },
/**/
   { "EqHelpOnObject",    (DM_EntryFunc) HelpOnObject      },
   { "EqHelpOnTag",       (DM_EntryFunc) HelpOnTag         },
   { "EqHelpViewFile",    (DM_EntryFunc) HelpViewFile      },
   { "EqHelpManPage",     (DM_EntryFunc) HelpManPage       },
/**/
   { "EqHelpOnItem",      (DM_EntryFunc) Obsolete1         },
   { "EqHelpOnVersion",   (DM_EntryFunc) Obsolete1         },
   { "EqQHelpOnObject",   (DM_EntryFunc) Obsolete1         },
   { "EqQHelpOnTag",      (DM_EntryFunc) Obsolete2         },
   { "EqCallHelp",        (DM_EntryFunc) Obsolete3         },
};

void dm_bind_default_callbacks( DM_ID dlgID )
{
   if (!DM_BindFunctions(CFuncMap, CFuncCount, dlgID, 0, DMF_Silent))
      DM_TraceMessage ("Missing callback functions", 0);
}
